﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Profiling_Students
{
    public class Student
    {
        public static int SleepTime = 10;

        public Student(string firstName, string lastName, int birthYear)
        {
            FirstName = firstName;
            LastName = lastName;
            BirthYear = birthYear;
        }

        public string FirstName { get; private set; }
        public string LastName { get; private set; }

        public string Name
        {
            get
            {
                Thread.Sleep(SleepTime);
                return LastName + " " + FirstName;
            }
        }
        public int BirthYear { get; private set; }

        public int Age
        {
            get
            {
                Thread.Sleep(SleepTime);
                return 2019 - BirthYear;
            }
        }

        public override string ToString()
        {
            return $"{Name} ({Age} year(s) old, born at {BirthYear})";
        }
    }
}
