﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace Profiling_Fibonacci
{
    class FibonacciMagic
    {
        private int calculateFibonacci(int number)
        {
            if (number <= 1)
            {
                return number;
            }
            return calculateFibonacci(number - 1) + calculateFibonacci(number - 2);
        }

        public double estimateGoldenRatio(int degree)
        {
            if (degree < 2 || degree > 45)
            {
                throw new ArithmeticException("Degree too high or too low.");
            }
            return calculateFibonacci(degree) / (double)calculateFibonacci(degree - 1);
        }
    }
}