﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Profiling_Students
{
    class Program
    {
        static void Main(string[] args)
        {
            Stopwatch stopwatch = new Stopwatch();
            stopwatch.Start();
        
            Random rnd = new Random();
            string[] firstName = new string[] { "Ábel", "Ádám", "Antal", "Anton", "Aranka", "Arisztotelész", "Arnold", "Ambrus", "Anna", "Adrien" };
            string[] lastName = new string[] { "Horváth", "Kovács", "Nagy", "Kis", "Szabó", "Varga", "Kiss", "Tóth", "Molnár", "Pék" };
                        
            StudentManager manager = new StudentManager();
            Student.SleepTime = 0;
            manager.GenerateRandomStudents(firstName, lastName);

            // Order students by their age
            Student.SleepTime = 5;
            manager.ListStudentsByAge();

            // Get random student by their name (n-times)
            //Student.SleepTime = 10;
            //for (int i=0;i<10;i++)
            //{
            //    string nameToFind = lastName[rnd.Next(lastName.Length)]+" "+firstName[rnd.Next(firstName.Length)];
            //    manager.GetStudentByName(nameToFind);
            //}

            stopwatch.Stop();
            Console.WriteLine("Time elapsed: {0}", stopwatch.Elapsed);
        }
    }
}
